let Run = require('./scripts/run');
module.exports = function (params, next, worker, processes, failed) {
    let _cluster = require('cluster');
    console.log('Beginning Setup..');
    Run(next).then(function () {
        if (_cluster.isMaster) {
            console.log('Handling Master Worker..');
            params(function (parameters) {
                let cpus = (parameters.processCount) ? parameters.processCount:require('os').cpus().length;
                console.log('Forking S_Loc_Instance Version', require('./package.json').version, "on", cpus, 'count(s)');
                for (let i = 0; i < cpus; i++) {
                    let workerP = _cluster.fork();
                    if (worker) {
                        workerP.on('message', function (message) {
                            worker(_cluster, workerP.id, message);
                        });
                    }
                }
            }, function (error) {
                if (failed) {
                    failed(error)
                }else {
                    processes(error)
                }
            })
        } else {
            if (processes) {
                console.log('Launching Process', _cluster.worker.id);
                processes(_cluster.worker.id, params.processCount)
            }
        }
    }).catch((failed) ? failed : processes);
}